#ifndef NGHOSTWATCHER_CONFIGURATION_NGHOSTWATCHERCONFIGURATIONPROPERTY_PROTECT
#define NGHOSTWATCHER_CONFIGURATION_NGHOSTWATCHERCONFIGURATIONPROPERTY_PROTECT

// ---------------------------------------------------------------------
// enum NGhostWatcher::Configuration::NGhostWatcherConfigurationProperty
// ---------------------------------------------------------------------

typedef enum NGhostWatcherConfigurationProperty
{
	NGHOST_WATCHER_CONFIGURATION_PROPERTY_DEVICE_NAME,

	NGHOST_WATCHER_CONFIGURATION_PROPERTY_AUTHENTICATION_USERNAME,
	NGHOST_WATCHER_CONFIGURATION_PROPERTY_AUTHENTICATION_PASSWORD,
	NGHOST_WATCHER_CONFIGURATION_PROPERTY_AUTHENTICATION_AUTHORIZED_TOKEN_IP,

	NGHOST_WATCHER_CONFIGURATION_PROPERTY_NETWORK_LISTENING_PORT,
	NGHOST_WATCHER_CONFIGURATION_PROPERTY_NETWORK_LISTENING_INTERFACE,

	NGHOST_WATCHER_CONFIGURATION_PROPERTIES
} NGhostWatcherConfigurationProperty;

// Default configuration
#define NGHOST_WATCHER_CONFIGURATION_PROPERTY_DEVICE_NAME_DEFAULT							"ToBeSet"

#define NGHOST_WATCHER_CONFIGURATION_PROPERTY_AUTHENTICATION_USERNAME_DEFAULT				"test"
#define NGHOST_WATCHER_CONFIGURATION_PROPERTY_AUTHENTICATION_PASSWORD_DEFAULT				"test"
#define NGHOST_WATCHER_CONFIGURATION_PROPERTY_AUTHENTICATION_AUTHORIZED_TOKEN_IP_DEFAULT	"127.0.0.1"

#define NGHOST_WATCHER_CONFIGURATION_PROPERTY_NETWORK_LISTENING_PORT_DEFAULT				NDEVICE_COMMON_TYPE_GHOST_WATCHER_LISTENING_PORT
#define NGHOST_WATCHER_CONFIGURATION_PROPERTY_NETWORK_LISTENING_INTERFACE_DEFAULT			"*"

/**
 * Get property name
 *
 * @param property
 * 		The property
 *
 * @return the property name
 */
const char *NGhostWatcher_Configuration_NGhostWatcherConfigurationProperty_GetName( NGhostWatcherConfigurationProperty property );

/**
 * Generate properties list
 *
 * @return the properties list
 */
__ALLOC char **NGhostWatcher_Configuration_NGhostWatcherConfigurationProperty_BuildPropertyList( void );

#ifdef NGHOSTWATCHER_CONFIGURATION_NGHOSTWATCHERCONFIGURATIONPROPERTY_INTERNE
__PRIVATE const char NGhostWatcherConfigurationPropertyName[ NGHOST_WATCHER_CONFIGURATION_PROPERTIES ][ 32 ] =
{
	"deviceName:",

	"username:",
	"password:",
	"trustedTokenIP:",

	"listenOnIP:",
	"listenOnPort:"
};
#endif // NGHOSTWATCHER_CONFIGURATION_NGHOSTWATCHERCONFIGURATIONPROPERTY_INTERNE

#endif // !NGHOSTWATCHER_CONFIGURATION_NGHOSTWATCHERCONFIGURATIONPROPERTY_PROTECT
